/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.support;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.stream.Collectors;

public class DependencySorter {

    public static interface DependencyProvider<T> {
        List<T> getDependencies(T inspectedObject);
    }

    public static <T> List<T> getSortedList(List<T> origin, DependencyProvider<T> provider) throws Exception {
        List<T> result = new LinkedList<>();

        // add independent objects
        result.addAll(
                origin.stream().filter(obj -> provider.getDependencies(obj).isEmpty())
                        .collect(Collectors.toList()));

        while (result.size() < origin.size()) {
            List<T> nextObjects = origin.stream().filter(obj -> !result.contains(obj))
                    .filter(obj -> result.containsAll(provider.getDependencies(obj)))
                    .collect(Collectors.toList());
            if (nextObjects.isEmpty())
                // TODO create more informative exception
                throw new UnsatisfiedDependenciesException(
                        origin.stream().filter(obj -> !result.contains(obj))
                                .collect(Collectors.toList()));
            result.addAll(nextObjects);
        }

        return result;
    }

    @SuppressWarnings("serial")
    public static class UnsatisfiedDependenciesException extends Exception {

        protected List<Object> objects;

        public UnsatisfiedDependenciesException(List<?> list) {
            super("Contains unsatisfied dependencies");
            this.objects = new ArrayList(list);
        }

        public List<Object> getObjects() {
            return objects;
        }
    }

}
